﻿IncludeFile "civetserver.pbi"

Global app.Civet_Server  

Procedure Resize()
  ResizeGadget(2,0,0,WindowWidth(0),WindowHeight(0)) 
EndProcedure 

;If you declare a runtime procedure and add a tag <?PB ElementFillTable() /> in the source html page remamed as .pbh 
;it will call the function and inline the code in the output
Runtime Procedure ElementsFillTable(*app.Civet_Server) 
  Protected sout.s,sum.f,a  
  sout = "<div><H2>Output from ElementsFillTable() Callback</h2></div>"
  sout + "<div class='table-wrapper'><table><thead><tr><th>Name</th><th>Description</th><th>Price</th></tr></thead>" + #LF$
  sout + "<tbody>" + #LF$ 
  For a = 1 To 20 
    sout + "<tr><td>Item " + Str(a) + "</td><td>Ante turpis integer aliquet porttitor.</td><td>" + StrF(a * 2.99,2) + "</td></tr>" + #LF$
    sum + (a * 2.99)  
  Next 
  sout + "</tbody><tfoot><tr><td colspan='2'></td><td>$" + StrF(sum,2) + "</td></tr></tfoot></table></div>"
  ProcedureReturn UTF8(sout) 
  
EndProcedure   

Procedure cbPost(ctx,*request.Civet_Server_Request) ;callbacks are threaded only use locally scoped resources  
  
  Debug "cbpost request type " +  *request\RequestType 
  Debug *request\Uri 
  
  ForEach *request\mquery()
    Debug *request\mquery()\name + " " + *request\mquery()\value 
  Next
  
  *request\Uri = "/elements.pbh"  ;redirect to  
  
  ProcedureReturn 0 ;to continue processing or 200  
  
EndProcedure  

Procedure cbGet(ctx,*request.Civet_Server_Request)
  
  Debug "cbGet request type " +  *request\RequestType 
  Debug *request\Uri 
  Debug GetFilePart(*request\Uri)
  
  ForEach *request\mquery()
    Debug MapKey(*request\mQuery()) + " " + *request\mquery()\name + " " + *request\mquery()\value 
  Next 
  
  If *request\mQuery("play")\value = "Waponez" 
    RunProgram("Http://127.0.0.1/Waponez.html")
    Civet_Server_Send_Response(ctx,"",0,0,"204 No Content") 
    ProcedureReturn 204
  EndIf     
  
  ProcedureReturn 0
EndProcedure   



app\packAddress =?Index  ;address for ezp pack archive of website in datasection. if unset will load from files. 
app\packsize = ?EndIndex - ?Index ;size of the pack to read in  
app\dirRelitive = "www"           ;required     

app\cbpost = @cbpost()   ;set a call back to process the post tokens 
app\cbget = @cbGet()     ;set a call back to process query strings from a get request 

Debug GetPathPart(ProgramFilename()) + app\dirRelitive
app\Server_Features = #MG_FEATURE_SUPPORTS_FILES 
app\Server_Settings\document_root = GetPathPart(ProgramFilename()) + app\dirRelitive ;set a root to be safe
app\Server_Settings\access_control_list = "-0.0.0.0/0,+127.0.0.1"  ;block all and then only allow connection from 127.0.0.1
app\Server_Settings\error_log_file = GetPathPart(ProgramFilename()) + "error.log"    ;set logs 
app\Server_Settings\access_log_file = GetPathPart(ProgramFilename()) + "access.log"  ;set logs 
app\Server_Settings\static_file_max_age = "0" ;nothing should be cached when debugging                     
app\Server_Settings\ssl_certificate = GetPathPart(ProgramFilename()) + "ssl_cert.pem" 
app\Server_Settings\enable_keep_alive = "yes" 

;app\Server_CallBacks\begin_request = @cb_begin_request() ;these callbacks are usefull for debug info 
;app\Server_CallBacks\end_request = @cb_end_request()     ;or if you want to overide civetweb, declared in civetweb.pbi 
;app\Server_CallBacks\connection_close = @cb_connection_closed() 
;app\Server_CallBacks\log_Access = @cb_log_access() 
;app\Server_CallBacks\log_message = @cb_log_message()  
;app\Server_CallBacks\http_error = @cb_http_error() 
;app\Server_CallBacks\init_connection = @cb_init_Connection() 
;app\Server_CallBacks\init_context = @cb_init_Context() 
;app\Server_CallBacks\exit_context = @cb_exit_context() 

;This can be used to pack your website to ezp so you can include it in the datasection
;it will be named as the folder of the app\dirRelitive setting with an extension of .ezp eg: www.ezp 
;Civet_Server_Create_Pack(app)

If Civet_Server_Start(app,80,443,"127.0.0.1")
  If OpenWindow(0,0,0,1024,600,"PB_Civet_Server_in_memSSL example of in memory embedded PB_Civet_Server " + app\Server_Settings\listening_ports,#PB_Window_SystemMenu |#PB_Window_SizeGadget |#PB_Window_MaximizeGadget) 
    WebGadget(2,0,0,1024,600,"https://127.0.0.1:"+ app\https_port) 
    BindEvent(#PB_Event_SizeWindow,@Resize()) 
    Repeat
    Until WaitWindowEvent(30) = #PB_Event_CloseWindow
  EndIf
  Civet_Server_Stop(app) 
Else 
  MessageRequester(GetFilePart(ProgramFilename()),"Cant start Server") 
  End
EndIf   

DataSection 
  Index:
  IncludeBinary "www.ezp"
  EndIndex:
EndDataSection 
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 89
; FirstLine = 71
; Folding = -
; EnableThread
; EnableXP
; Executable = civet_server_in_mem.exe
; CommandLine = _WIN32_IE=$0600
; CompileSourceDirectory
; Compiler = PureBasic 5.62 (Windows - x86)
; EnablePurifier = 1,1,1,1